"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _fs = require("fs");

var _path = require("path");

var _globby = _interopRequireDefault(require("globby"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default(api) {
  const _api$placeholder = api.placeholder,
        IMPORT = _api$placeholder.IMPORT,
        RENDER = _api$placeholder.RENDER;
  const paths = api.service.paths;
  const winPath = api.utils.winPath;
  const dvaContainerPath = (0, _path.join)(paths.absTmpDirPath, 'DvaContainer.js');

  function getModels() {
    const modelPaths = _globby.default.sync('**/models/*.js', {
      cwd: paths.absSrcPath
    });

    return modelPaths.map(path => `
    app.model({ ...(require('../../${path}').default) });
  `.trim()).join('\r\n');
  }

  function getPlugins() {
    const pluginPaths = _globby.default.sync('../../plugins/*.js', {
      cwd: paths.absSrcPath
    });

    return pluginPaths.map(path => `
    app.use(require('./${path}').default);
  `.trim()).join('\r\n');
  }

  api.register('generateFiles', () => {
    const tpl = (0, _path.join)(__dirname, '../template/DvaContainer.js');
    let tplContent = (0, _fs.readFileSync)(tpl, 'utf-8');
    tplContent = tplContent.replace('<%= RegisterPlugins %>', getPlugins()).replace('<%= RegisterModels %>', getModels());
    (0, _fs.writeFileSync)(dvaContainerPath, tplContent, 'utf-8');
  });
  api.register('modifyEntryFile', ({
    memo
  }) => {
    return memo.replace(RENDER, `
const DvaContainer = require('./DvaContainer').default;
ReactDOM.render(React.createElement(
  DvaContainer,
  null,
  React.createElement(require('./router').default)
), document.getElementById('root'));
      `.trim());
  });
  api.register('modifyAFWebpackOpts', ({
    memo
  }) => {
    memo.alias = _extends({}, memo.alias, {
      dva: (0, _path.dirname)(require.resolve('dva/package')),
      'dva-loading': require.resolve('dva-loading')
    });
    return memo;
  });
}